﻿using Microsoft.Xna.Framework;
using NativeHelper;
using NativeHelper.Data;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CpuSkinningDataTypes
{  

    public static class NativeExtensions
    {
        public static MatrixData ToMatrixData(this Matrix source)
        {
            MatrixData result;
            result.M11 = source.M11;
            result.M12 = source.M12;
            result.M13 = source.M13;
            result.M14 = source.M14;
            result.M21 = source.M21;
            result.M22 = source.M22;
            result.M23 = source.M23;
            result.M24 = source.M24;
            result.M31 = source.M31;
            result.M32 = source.M32;
            result.M33 = source.M33;
            result.M34 = source.M34;
            result.M41 = source.M41;
            result.M42 = source.M42;
            result.M43 = source.M43;
            result.M44 = source.M44; 
            return result;
        }

        public static Matrix3x4Data ToMatrix3x4Data(this Matrix source)
        {
            Matrix3x4Data result;
            result.M11 = source.M11;
            result.M12 = source.M12;
            result.M13 = source.M13;
            result.M21 = source.M21;
            result.M22 = source.M22;
            result.M23 = source.M23;
            result.M31 = source.M31;
            result.M32 = source.M32;
            result.M33 = source.M33;
            result.M41 = source.M41;
            result.M42 = source.M42;
            result.M43 = source.M43;
            return result;
        }

        public static SkinVertex ToSkinVertex(this CpuVertex source)
        {   
            SkinVertex result;
            result.Position = source.Position.ToVector3Data();
            result.Normal = source.Normal.ToVector3Data();
            result.TextureCoordinate = source.TextureCoordinate.ToVector2Data();
            result.BlendWeights = source.BlendWeights.ToVector4Data();
            result.BlendIndices = source.BlendIndices.ToInt4Data();
            return result;
        }

        public static Vector4Data ToVector4Data(this Vector4 source)
        {
            Vector4Data result;
            result.X = source.X;
            result.Y = source.Y;
            result.Z = source.Z; 
            result.W = source.W;
            return result;
        }

        public static Vector3Data ToVector3Data(this Vector3 source)
        {
            Vector3Data result;
            result.X = source.X;
            result.Y = source.Y;
            result.Z = source.Z;
            return result;
        }

        public static Vector2Data ToVector2Data(this Vector2 source)
        {
            Vector2Data result;
            result.X = source.X;
            result.Y = source.Y;            
            return result;
        }

        public static Int4Data ToInt4Data(this Vector4 source)
        {
            Int4Data result;
            result.X = (int)source.X;
            result.Y = (int)source.Y;
            result.Z = (int)source.Z;
            result.W = (int)source.W;
            return result;
        }

        public static Vector3 ToVector3(this Vector3Data source)
        {
            Vector3 result;
            result.X = source.X;
            result.Y = source.Y;
            result.Z = source.Z;
            return result;
        }



    }
}
