﻿#pragma once
#include <vector>
#include "Data/Matrix.h"
#include "SkinVertex.h"
#include "VertexPositionNormalTextureData.h"

using namespace Platform;
using namespace NativeHelper::Data;

namespace NativeHelper
{
    public ref class SkinnedModel sealed
    {
	private:
		SkinVertex* _skinVertices;

		DirectX::XMVECTOR* _skinVerticesPositions;
		DirectX::XMVECTOR* _skinVerticesNormals;

		int _verticesLength;
		
    public:
        SkinnedModel(void);
		virtual ~SkinnedModel(void);
		void SetSkinVertices(const Platform::Array<SkinVertex>^ skinVertices);
		void Skin(const Array<Matrix3x4Data>^ bones, Platform::WriteOnlyArray<VertexPositionNormalTextureData>^ vertices);
		void SkinParral(const Array<Matrix3x4Data>^ bones, Platform::WriteOnlyArray<VertexPositionNormalTextureData>^ vertices);
		
	private:
		void DoSkinVertex(	Vector3Data* position, Vector3Data*  Normal,
							Vector4Data* blendIndices, Vector4Data* blendWeights,
							Vector3Data* skinnedPosition, Vector3Data* skinnedNormal);


    };
}